#pragma once
#include <openvr.h>

#include "glut.h"
#include "SteamTracking.h"
#include <ctime>

#include <cmath>
#include <cstdio>

#include <Windows.h>
#include <Ole2.h>

#include <vector>
#include <iostream>
#include <fstream>
#include <sstream>

#include <glm/vec3.hpp>
#include <glm/gtc/type_ptr.hpp>
#include "glm/gtc/matrix_transform.hpp"

#include <Kinect.h>
#include "Camera.h"
#include "objloader.hpp"

const int width = 512;
const int height = 424;
const int colorwidth = 1920;
const int colorheight = 1080;

void mainRenderLoop();
void keyPressed(unsigned char key, int x, int y);
void keyReleased(unsigned char key, int x, int y);
void mouseButton(int button, int state, int x, int y);
void mouseMove(int x, int y);

void captureNextFrame(vr::VREvent_t event);
void writePointCloud();
void close();

void setupGrid();
void setupFrameBuffer();

void reshapeFunction(int width, int height);

void printVector(glm::vec3 vector);
float degreeToRadian(float degree);

void convertTxtToPnts();
void writePTNS(std::vector<glm::vec3> exportpoints, std::vector<unsigned char> exportColors, const char* filename);


struct pntsHeader {
	unsigned char magic[4] = { 'p','n','t','s' };
	unsigned int version = 1;
	unsigned int byteLenght = 28;
	unsigned int featureTableJSONByteLenght = 0;
	unsigned int featureTableByteLenght = 0;
	unsigned int batchTableJSONByteLength = 0;
	unsigned int batchTableBinaryLenght = 0;
};